﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@

Sub Class_Globals
	Dim W As MLwifi
	Dim WScan As MLScan
	Dim WSCanDone As Boolean
	Dim ScanSuccess As Boolean = False
	
	Dim OldSSID As String = ""
	Dim NewSSID As String = ""
'	Public CurrentSSID As String = ""
	
	Public IsInitialized As Boolean = False
	
	Type WifiStatusInfo(StatusValue As Int, StatusString As String)
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Sub Initialize

	WSCanDone = False
	WifiScan(NewSSID)
	W.debug = True
	IsInitialized = True

End Sub

Public Sub GetSSID As String
	Return W.WifiSSID
End Sub

Public Sub WifiScan(SSID As String) As ResumableSub
	Try
		If Not(WSCanDone) Then
			WScan.startscan("WiFi", True)
			Wait For WiFi_ScanDone (Results() As String, Count As Int)
			Return CheckForAP(SSID)
		Else
			Log("Scan can only be done once")
		End If
	Catch
		Log("AA Scan: " & LastException)
	End Try
	WSCanDone = True
	Return False
End Sub

Sub CheckForAP(SSID As String) As Boolean
	Try
		For Each Entry In WScan.wifis 'list of Networks found
			Dim EntryInfo() As String = Regex.Split(",", Entry)
			If EntryInfo(0) = SSID Then
				Return True
			End If
		Next
	Catch
		Log("Check for AP: " & LastException)
	End Try
	Return False
End Sub

Public Sub WifiCheckAP(SSID As String)As ResumableSub
	If Not(WSCanDone) Then
		wait for WifiScan Complete '(result As Boolean)
	End If
	NewSSID = SSID
	WScan.updateWifiList

	Wait For WiFi_ScanDone(Results() As String, Count As Int) '15/12/20
	ScanSuccess = CheckForAP(SSID) 'Results, Count)

	Return ScanSuccess
End Sub

public Sub SetAP(APName As String, APPass As String, SecType As Int, Timeout As Int) As ResumableSub
	Try
		OldSSID = W.WifiSSID
		Select True
			Case w.APIVersion >= 29
				Log("Connect 29")
				W.removeWifiAP(APName)
				W.connectWifiAP(APName, SecType, APPass, Timeout)
				wait for Wifi_ConnectionResult (Success As Boolean)
			Case w.APIVersion = 28
				Log("Save 28")
				W.saveWifiAP(APName, SecType, APPass, True, Timeout)
				wait for Wifi_ConnectionResult (Success As Boolean)
			Case Else
				Log("27 and lower, Save/ connect")
				W.saveWifiAP(APName, SecType, APPass, True, Timeout)
				wait for Wifi_ConnectionResult (Success As Boolean)
		End Select

		Return Success
	Catch
		Log("SetAp error: " & LastException)
	End Try
	Return False
End Sub

public Sub ResetAP As ResumableSub
	Dim RAP As Boolean = False
	Select True
		Case W.APIversion >= 29
			RAP = w.disconnectWifiAP
		Case w.APIVersion = 28
			RAP = w.removeWifiAP(W.WifiSSID)
		Case Else
			W.reconnectWifiAP(OldSSID, 1000)
			wait for Wifi_ConnectionResult (Success As Boolean)
			RAP = Success
	End Select
	
	'returned values are not always reliable so check/ wait for the SSID
	RAP = False
	For i = 0 To 500
		If W.WifiSSID = OldSSID Then
			RAP = True
			Exit
		End If
		Sleep(100)
	Next
	Return RAP
End Sub

